Index: /java/main/src/main/java/com/framsticks/core/Entity.java
===================================================================
--- /java/main/src/main/java/com/framsticks/core/Entity.java	(revision 85)
+++ /java/main/src/main/java/com/framsticks/core/Entity.java	(revision 86)
@@ -3,5 +3,6 @@
 import javax.annotation.OverridingMethodsMustInvokeSuper;
 
-import com.framsticks.params.FramsClass;
+import com.framsticks.params.annotations.FramsClassAnnotation;
+import com.framsticks.params.annotations.ParamAnnotation;
 import com.framsticks.util.dispatching.Thread;
 import com.framsticks.util.dispatching.Dispatcher;
@@ -14,8 +15,10 @@
  * @author Piotr Sniegowski
  */
+@FramsClassAnnotation
 public abstract class Entity implements Dispatcher<Entity> {
 
-	private final static Logger log = Logger.getLogger(Entity.class.getName());
+	private final static Logger log = Logger.getLogger(Entity.class);
 
+	@ParamAnnotation
 	protected String name = "entity";
 	protected EntityOwner owner;
@@ -109,6 +112,3 @@
 	}
 
-	public static void constructFramsClass(FramsClass.Constructor constructor) {
-		constructor.method("getName");
-	}
 }
Index: /java/main/src/main/java/com/framsticks/core/Instance.java
===================================================================
--- /java/main/src/main/java/com/framsticks/core/Instance.java	(revision 85)
+++ /java/main/src/main/java/com/framsticks/core/Instance.java	(revision 86)
@@ -23,5 +23,4 @@
 	private static final Logger log = Logger.getLogger(Instance.class.getName());
 
-
 	protected Node root;
 
@@ -34,5 +33,5 @@
 	protected void run() {
 		super.run();
-		root = new Node((CompositeParam)Param.build().name("Instance").id(name).type("o").finish(), null);
+		root = new Node((CompositeParam) Param.build().name("Instance").id(name).type("o").finish(), null);
 		com.framsticks.model.Package.register(registry);
 	}
@@ -112,5 +111,4 @@
 	}
 
-
 	protected void fireListChange(Path path, ListChange change) {
 		assert isActive();
@@ -127,10 +125,8 @@
 	}
 
-
 	public final FramsClass getInfoFromCache(Path path) {
 		return getInfoFromCache(path.getTop().getParam().getContainedTypeName());
 	}
 
-
 	public FramsClass getInfoFromCache(String id) {
 		assert isActive();
@@ -140,9 +136,8 @@
 	protected Registry registry = new Registry();
 
-	public AccessInterface createAccess(String name) {
+	public AccessInterface createAccess(String name) throws ConstructionException {
 		assert isActive();
 		return registry.createAccess(name);
 	}
-
 
 	// TODO: make ValueParam
@@ -165,11 +160,11 @@
 	public final AccessInterface bindAccess(Node node) {
 		assert node.getObject() != null;
-		AccessInterface access = registry.prepareAccess(node.getParam());
-		if (access == null) {
-			log.error("missing access for: " + node.getParam());
-			return null;
-		}
-		access.select(node.getObject());
-		return access;
+
+		try {
+			return registry.prepareAccess(node.getParam()).select(node.getObject());
+		} catch (ConstructionException e) {
+			log.error("failed to bind access for " + node.getParam() + ": " + e);
+		}
+		return null;
 	}
 
Index: /java/main/src/main/java/com/framsticks/gui/controls/Control.java
===================================================================
--- /java/main/src/main/java/com/framsticks/gui/controls/Control.java	(revision 85)
+++ /java/main/src/main/java/com/framsticks/gui/controls/Control.java	(revision 86)
@@ -1,8 +1,12 @@
 package com.framsticks.gui.controls;
 
+import java.awt.BorderLayout;
+
+import javax.swing.JComponent;
+import javax.swing.JPanel;
+
+import com.framsticks.gui.Frame;
 import com.framsticks.params.Flags;
 import com.framsticks.params.Param;
-import javax.swing.*;
-import java.awt.*;
 
 /**
Index: /java/main/src/main/java/com/framsticks/hosting/ServerInstance.java
===================================================================
--- /java/main/src/main/java/com/framsticks/hosting/ServerInstance.java	(revision 85)
+++ /java/main/src/main/java/com/framsticks/hosting/ServerInstance.java	(revision 86)
@@ -3,5 +3,7 @@
 import com.framsticks.core.*;
 import com.framsticks.params.CompositeParam;
+import com.framsticks.params.ConstructionException;
 import com.framsticks.params.FramsClass;
+import com.framsticks.params.FramsClassBuilder;
 import com.framsticks.params.Param;
 import com.framsticks.core.LocalInstance;
@@ -42,5 +44,5 @@
 		hosted.setName("hosted");
 		hosted.configure(hostedConfig);
-		root = new Node((CompositeParam)Param.build().name("root").id("root").type("o" + hosted.getClass().getCanonicalName()).finish(), hosted);
+		root = new Node((CompositeParam) Param.build().name("root").id("root").type("o" + hosted.getClass().getCanonicalName()).finish(), hosted);
 	}
 
@@ -57,5 +59,10 @@
 		try {
 			Class<?> nativeClass = Class.forName(id);
-			FramsClass framsClass = new FramsClass.Constructor(nativeClass, id).getResult();
+			FramsClass framsClass = FramsClassBuilder.buildForClass(nativeClass);
+
+			if (!framsClass.getId().equals(id)) {
+				log.error("no matching id");
+				return null;
+			}
 
 			registry.registerReflectedClass(null, id, nativeClass);
@@ -63,4 +70,6 @@
 			return framsClass;
 		} catch (ClassNotFoundException ignored) {
+		} catch (ConstructionException e) {
+			log.error("failed to use info from cache: " + e);
 		}
 
Index: /java/main/src/main/java/com/framsticks/model/BaseJoint.java
===================================================================
--- /java/main/src/main/java/com/framsticks/model/BaseJoint.java	(revision 85)
+++ /java/main/src/main/java/com/framsticks/model/BaseJoint.java	(revision 86)
@@ -1,4 +1,5 @@
 package com.framsticks.model;
 
+import com.framsticks.params.annotations.ParamAnnotation;
 import com.framsticks.util.math.Point3d;
 
@@ -8,15 +9,11 @@
 public class BaseJoint {
 
-	/** stif */
-	public Double stiffness;
-	public Double getStif() { return stiffness; }
-	public void setStif(Double stif) { stiffness = stif; }
+	@ParamAnnotation(id = "stif")
+	public double stiffness;
 
-	/** rotstif */
-	public Double rotationStiffness;
-	public Double getRotstif() { return rotationStiffness; }
-	public void setRotstif(Double rotstif) { rotationStiffness = rotstif; }
+	@ParamAnnotation(id = "rotstif")
+	public double rotationStiffness;
 
-	/** rx, ry, rz*/
+	@ParamAnnotation
 	public double rx, ry, rz;
 
@@ -24,5 +21,5 @@
 	public void setRotation(Point3d r) { rx = r.x; ry = r.y; rz = r.z; }
 
-	/** dx, dy, dz*/
+	@ParamAnnotation
 	public double dx, dy, dz;
 
Index: /java/main/src/main/java/com/framsticks/model/BaseNeuro.java
===================================================================
--- /java/main/src/main/java/com/framsticks/model/BaseNeuro.java	(revision 85)
+++ /java/main/src/main/java/com/framsticks/model/BaseNeuro.java	(revision 86)
@@ -1,3 +1,5 @@
 package com.framsticks.model;
+
+import com.framsticks.params.annotations.ParamAnnotation;
 
 /**
@@ -5,8 +7,7 @@
  */
 public class BaseNeuro {
-	/** inputCount */
-	public Integer inputCount;
-	public Integer getGetInputCount() { return inputCount; }
-	public void setGetInputCount(Integer getInputCount) { inputCount = getInputCount; }
+
+	@ParamAnnotation(id = "getInputCount")
+	public int inputCount;
 
 
Index: /java/main/src/main/java/com/framsticks/model/BasePart.java
===================================================================
--- /java/main/src/main/java/com/framsticks/model/BasePart.java	(revision 85)
+++ /java/main/src/main/java/com/framsticks/model/BasePart.java	(revision 86)
@@ -1,4 +1,5 @@
 package com.framsticks.model;
 
+import com.framsticks.params.annotations.ParamAnnotation;
 import com.framsticks.util.math.Orientation;
 import com.framsticks.util.math.Point3d;
@@ -8,5 +9,6 @@
  */
 public class BasePart {
-	/** x, y, z */
+
+	@ParamAnnotation
 	public double x, y, z;
 
@@ -14,20 +16,14 @@
 	public void setPosition(Point3d p) { x = p.x; y = p.y; z = p.z; }
 
-	/** m */
-	public Double mass = 0.0;
-	public Double getM() { return mass; }
-	public void setM(Double m) { mass = m; }
+	@ParamAnnotation(id = "m")
+	public double mass = 0.0;
 
-	/** s */
-	public Double size = 0.0;
-	public Double getS() { return size; }
-	public void setS(Double s) { size = s; }
+	@ParamAnnotation(id = "s")
+	public double size = 0.0;
 
-	/** fr */
-	public Double friction;
-	public Double getFr() { return friction; }
-	public void setFr(Double fr) { friction = fr; }
+	@ParamAnnotation(id = "fr")
+	public double friction;
 
-
+	@ParamAnnotation
 	public double oxx, oxy, oxz, oyx, oyy, oyz, ozx, ozy, ozz;
 
Index: /java/main/src/main/java/com/framsticks/model/Creature.java
===================================================================
--- /java/main/src/main/java/com/framsticks/model/Creature.java	(revision 85)
+++ /java/main/src/main/java/com/framsticks/model/Creature.java	(revision 86)
@@ -1,5 +1,6 @@
 package com.framsticks.model;
 
-import com.framsticks.params.FramsClass;
+import com.framsticks.params.annotations.FramsClassAnnotation;
+import com.framsticks.params.annotations.ParamAnnotation;
 import com.framsticks.util.math.Point3d;
 
@@ -7,91 +8,80 @@
 import java.util.List;
 
+@FramsClassAnnotation
 public class Creature {
+
+	@ParamAnnotation
 	public String name;
 
+	@ParamAnnotation
 	public String genotype;
 
+	@ParamAnnotation
 	public String info;
 
+	@ParamAnnotation
 	public Object group;
 
-	public Integer generation;
-	public Integer getGnum() { return generation; }
-	public void setGnum(Integer gnum) { generation = gnum; }
+	@ParamAnnotation(id = "gnum")
+	public int generation;
 
-	public Integer buildProblems;
-	public Integer getBuildproblems() { return buildProblems; }
-	public void setBuildproblems(Integer buildproblems) { buildProblems = buildproblems; }
+	@ParamAnnotation(id = "buildproblems")
+	public int buildProblems;
 
-	public Double startingEnergy;
-	public Double getEnerg0() { return startingEnergy; }
-	public void setEnerg0(Double energ0) { startingEnergy = energ0; }
+	@ParamAnnotation(id = "energ0")
+	public double startingEnergy;
 
-	public Double idlePowerConsumption;
-	public Double getIdleen() { return idlePowerConsumption; }
-	public void setIdleen(Double idleen) { idlePowerConsumption = idleen; }
+	@ParamAnnotation(id = "idleen")
+	public double idlePowerConsumption;
 
-	public Double energy;
+	@ParamAnnotation
+	public double energy;
 
-	public Double energyIncome;
-	public Double getEnergy_p() { return energyIncome; }
-	public void setEnergy_p(Double energy_p) { energyIncome = energy_p; }
+	@ParamAnnotation(id = "energy_p")
+	public double energyIncome;
 
-	public Double energyCosts;
-	public Double getEnergy_m() { return energyCosts; }
-	public void setEnergy_m(Double energy_m) { energyCosts = energy_m; }
+	@ParamAnnotation(id = "energy_m")
+	public double energyCosts;
 
-	public Double energyBalance;
-	public Double getEnergy_b() { return energyBalance; }
-	public void setEnergy_b(Double energy_b) { energyBalance = energy_b; }
+	@ParamAnnotation(id = "energy_b")
+	public double energyBalance;
 
-	public Integer performanceCalculation;
-	public Integer getPerf() { return performanceCalculation; }
-	public void setPerf(Integer perf) { performanceCalculation = perf; }
+	@ParamAnnotation(id = "perf")
+	public int performanceCalculation;
 
-	public Boolean neuralNetworkEnabled;
+	@ParamAnnotation(id = "nnenabled")
+	public boolean neuralNetworkEnabled;
 
-	public Boolean getNnenabled() { return neuralNetworkEnabled; }
-	public void setNnenabled(Boolean nnenabled) { neuralNetworkEnabled = nnenabled; }
+	@ParamAnnotation(id = "bodysim")
+	public boolean bodySimulation;
 
-	public Boolean bodySimulation;
-	public Boolean getBodysim() { return bodySimulation; }
-	public void setBodysim(Boolean bodysim) { bodySimulation = bodysim; }
+	@ParamAnnotation(id = "selfcol")
+	public boolean selfCollisions;
 
-	public Boolean selfCollisions;
-	public Boolean getSelfcol() { return selfCollisions; }
-	public void setSelfcol(Boolean selfcol) { selfCollisions = selfcol; }
+	@ParamAnnotation(id = "lifespan")
+	public int lifeSpan;
 
-	public Integer lifeSpan;
-	public Integer getLifespan() { return lifeSpan; }
-	public void setLifespan(Integer lifespan) { lifeSpan = lifespan; }
+	@ParamAnnotation
+	public double distance;
 
-	public Double distance;
+	@ParamAnnotation(id = "c_velocity")
+	public double currentVelocity;
 
-	public Double currentVelocity;
-	public Double getC_velocity() { return currentVelocity; }
-	public void setC_velocity(Double c_velocity) { currentVelocity = c_velocity; }
+	@ParamAnnotation(id = "c_vertvelocity")
+	public double currentVerticalVelocity;
 
-	public Double currentVerticalVelocity;
-	public Double getC_vertvelocity() { return currentVerticalVelocity; }
-	public void setC_vertvelocity(Double c_vertvelocity) { currentVerticalVelocity = c_vertvelocity; }
+	@ParamAnnotation(id = "c_vertpos")
+	public double currentVerticalPosition;
 
-	public Double currentVerticalPosition;
-	public Double getC_vertpos() { return currentVerticalPosition; }
-	public void setC_vertpos(Double c_vertpos) { currentVerticalPosition = c_vertpos; }
+	@ParamAnnotation(id = "velocity")
+	public double averageVelocity;
 
-	public Double averageVelocity;
-	public Double getVelocity() { return averageVelocity; }
-	public void setVelocity(Double c_velocity) { averageVelocity = c_velocity; }
+	@ParamAnnotation(id = "vertvel")
+	public double averageVerticalVelocity;
 
-	public Double averageVerticalVelocity;
-	public Double getVertvel() { return averageVerticalVelocity; }
-	public void setVertvel(Double c_vertvelocity) { averageVerticalVelocity = c_vertvelocity; }
+	@ParamAnnotation(id = "vertpos")
+	public double averageVerticalPosition;
 
-	public Double averageVerticalPosition;
-	public Double getVertpos() { return averageVerticalPosition; }
-	public void setVertpos(Double c_vertpos) { averageVerticalPosition = c_vertpos; }
-
-	/** pos_x, pos_y, pos_z*/
+	@ParamAnnotation
 	public double pos_x, pos_y, pos_z;
 
@@ -99,4 +89,5 @@
 	public void setPosition(Point3d pos) { pos_x = pos.x; pos_y = pos.y; pos_z = pos.z; }
 
+	@ParamAnnotation
 	public double size_x, size_y, size_z;
 
@@ -106,4 +97,5 @@
 
 	/** center_x, center_y, center_z*/
+	@ParamAnnotation
 	public double center_x, center_y, center_z;
 
@@ -111,37 +103,55 @@
 	public void setCenter(Point3d center) { center_x = center.x; center_y = center.y; center_z = center.z; }
 
-	public Integer getNumparts() { return parts.size(); }
-	public void setNumparts(Integer numparts) { }
+	@ParamAnnotation
+	public int getNumparts() { return parts.size(); }
+	@ParamAnnotation
+	public void setNumparts(int numparts) { }
 
-	public Integer getNumjoints() { return joints.size(); }
-	public void setNumjoints(Integer numjoints) { }
+	@ParamAnnotation
+	public int getNumjoints() { return joints.size(); }
+	@ParamAnnotation
+	public void setNumjoints(int numjoints) { }
 
-	public Integer getNumneurons() { return neurons.size(); }
-	public void setNumneurons(Integer numneurons) { }
+	@ParamAnnotation
+	public int getNumneurons() { return neurons.size(); }
+	@ParamAnnotation
+	public void setNumneurons(int numneurons) { }
 
 	public Object[] userFields = new Object[3];
+	@ParamAnnotation
 	public Object getUser1() { return userFields[0]; }
+	@ParamAnnotation
 	public void setUser1(Object user1) { userFields[0] = user1; }
 
+	@ParamAnnotation
 	public Object getUser2() { return userFields[1]; }
+	@ParamAnnotation
 	public void setUser2(Object user2) { userFields[1] = user2; }
 
+	@ParamAnnotation
 	public Object getUser3() { return userFields[2]; }
+	@ParamAnnotation
 	public void setUser3(Object user3) { userFields[2] = user3; }
 
-	public Integer selfCollisionMask;
-	public Integer getSelfmask() { return selfCollisionMask; }
-	public void setSelfmask(Integer selfmask) { selfCollisionMask = selfmask; }
+	@ParamAnnotation(id = "selfmask")
+	public int selfCollisionMask;
 
-	public Integer otherCollisionMask;
-	public Integer getOthermask() { return otherCollisionMask; }
-	public void setOthermask(Integer othermask) { otherCollisionMask = othermask; }
+	@ParamAnnotation(id = "othermask")
+	public int otherCollisionMask;
 
+	@ParamAnnotation(id = "selfcolstate")
+	public boolean selfCollisionsState;
+
+	@ParamAnnotation
 	public String uid;
 
-	public Integer index;
+	@ParamAnnotation
+	public int index;
 
+	@ParamAnnotation
 	public final List<Part> parts = new ArrayList<Part>();
+	@ParamAnnotation
 	public final List<Joint> joints = new ArrayList<Joint>();
+	@ParamAnnotation
 	public final List<NeuroDef> neurodefs = new ArrayList<NeuroDef>();
 
@@ -150,6 +160,9 @@
 	public final List<NeuroDef> getNeuroDefs() { return neurodefs; }
 
+	@ParamAnnotation
 	public final List<MechPart> mechparts = new ArrayList<MechPart>();
+	@ParamAnnotation
 	public final List<MechJoint> mechjoints = new ArrayList<MechJoint>();
+	@ParamAnnotation
 	public final List<Neuro> neurons = new ArrayList<Neuro>();
 
@@ -158,15 +171,3 @@
 	public final List<Neuro> getNeurons() { return neurons; }
 
-
-
-	public static void constructFramsClass(FramsClass.Constructor constructor) {
-		constructor.field("name");
-		constructor.field("parts");
-		constructor.field("joints");
-		constructor.field("neurodefs");
-		constructor.field("mechparts");
-		constructor.field("mechjoints");
-		constructor.field("neurons");
-	}
-
 }
Index: /java/main/src/main/java/com/framsticks/model/Genotype.java
===================================================================
--- /java/main/src/main/java/com/framsticks/model/Genotype.java	(revision 85)
+++ /java/main/src/main/java/com/framsticks/model/Genotype.java	(revision 86)
@@ -1,74 +1,115 @@
 package com.framsticks.model;
+
+import com.framsticks.params.annotations.FramsClassAnnotation;
+import com.framsticks.params.annotations.ParamAnnotation;
 
 
 // import org.apache.log4j.Logger;
 
+@FramsClassAnnotation
 public class Genotype extends Model {
 	// private final static Logger log = Logger.getLogger(Genotype.class);
 
+	@ParamAnnotation
 	public String name;
+
+	@ParamAnnotation
 	public String genotype;
+
+	@ParamAnnotation
 	public String info;
 
-	public Double similarity;
-	public Double getSimi() { return similarity; }
-	public void setSimi(Double simi) { similarity = simi; }
+	@ParamAnnotation(id = "simi")
+	public double similarity;
 
-	public Double brainConnections;
-	public Double getNumconnections() { return brainConnections; }
-	public void setNumconnections(Double numconnections) { brainConnections = numconnections; }
+	@ParamAnnotation(id = "numconnections")
+	public double brainConnections;
 
-    public Integer ordinalNumber;
-	public Integer getNum() { return ordinalNumber; }
-	public void setNum(Integer num) { ordinalNumber = num; }
+	@ParamAnnotation(id = "num")
+	public int ordinalNumber;
 
-    public Integer generation;
-	public Integer getGnum() { return generation; }
-	public void setGnum(Integer gnum) { generation = gnum; }
+	@ParamAnnotation(id = "gnum")
+	public int generation;
 
-	public Integer instances;
+	@ParamAnnotation
+	public int instances;
 
-	public Integer lifeSpan;
-	public Integer getLifespan() { return lifeSpan; }
-	public void setLifespan(Integer lifespan) { lifeSpan = lifespan; }
+	@ParamAnnotation(id = "lifespan")
+	public double lifeSpan;
 
-	public Double velocity;
-	public Double distance;
+	@ParamAnnotation
+	public double velocity;
 
-	public Double verticalVelocity;
-	public Double getVertvel() { return verticalVelocity; }
-	public void setVertvel(Double vertvel) { verticalVelocity = vertvel; }
+	@ParamAnnotation
+	public double distance;
 
-	public Double verticalPosition;
-	public Double getVertpos() { return verticalPosition; }
-	public void setVertpos(Double vertpos) { verticalPosition = vertpos; }
+	@ParamAnnotation(id = "vertvel")
+	public double verticalVelocity;
 
-	public Double fitness;
-	public Double getFit() { return fitness; }
-	public void setFit(Double fit) { fitness = fit; }
+	@ParamAnnotation(id = "vertpos")
+	public double verticalPosition;
 
-	public Double finalFitness;
-	public Double getFit2() { return finalFitness; }
-	public void setFit2(Double fit2) { finalFitness = fit2; }
+	@ParamAnnotation(id = "fit")
+	public double fitness;
 
+	@ParamAnnotation(id = "fit2")
+	public double finalFitness;
+
+	@ParamAnnotation(id = "f0genotype")
 	public String genotypeInF0;
-	public String getF0genotype() { return genotypeInF0; }
-	public void setF0genotype(String f0genotype) { genotypeInF0 = f0genotype; }
 
+	@ParamAnnotation(id = "convtrace1")
 	public String conversionBacktrace;
-	public String getConvtrace1() { return conversionBacktrace; }
-	public void setConvtrace1(String convtrace1) { conversionBacktrace = convtrace1; }
+
+	@ParamAnnotation
+	public boolean isValid;
 
 	public Object[] userFields = new Object[3];
+	@ParamAnnotation
 	public Object getUser1() { return userFields[0]; }
+	@ParamAnnotation
 	public void setUser1(Object user1) { userFields[0] = user1; }
 
+	@ParamAnnotation
 	public Object getUser2() { return userFields[1]; }
+	@ParamAnnotation
 	public void setUser2(Object user2) { userFields[1] = user2; }
 
+	@ParamAnnotation
 	public Object getUser3() { return userFields[2]; }
+	@ParamAnnotation
 	public void setUser3(Object user3) { userFields[2] = user3; }
 
+	@ParamAnnotation
 	public String uid;
+
+	@ParamAnnotation
+	public double getStrsiz() { return getNumparts(); }
+	@ParamAnnotation
+	public void setStrsiz(double strsiz) { setNumparts(strsiz); }
+
+
+	@ParamAnnotation
+	public double getStrjoints() { return getNumjoints(); }
+	@ParamAnnotation
+	public void setStrjoints(double strjoints) { setNumjoints(strjoints); }
+
+
+	@ParamAnnotation
+	public double getNnsiz() { return getNumneurons(); }
+	@ParamAnnotation
+	public void setNnsiz(double nnsiz) { setNumneurons(nnsiz); }
+
+
+	@ParamAnnotation
+	public double getNncon() { return brainConnections; }
+	@ParamAnnotation
+	public void setNncon(double nncon) { this.brainConnections = nncon; }
+
+	@ParamAnnotation
+	public int getPopsiz() { return instances; }
+	@ParamAnnotation
+	public void setPopsiz(int popsiz) { this.instances = popsiz; }
+
 
 }
Index: /java/main/src/main/java/com/framsticks/model/Joint.java
===================================================================
--- /java/main/src/main/java/com/framsticks/model/Joint.java	(revision 85)
+++ /java/main/src/main/java/com/framsticks/model/Joint.java	(revision 86)
@@ -1,3 +1,6 @@
 package com.framsticks.model;
+
+import com.framsticks.params.annotations.FramsClassAnnotation;
+import com.framsticks.params.annotations.ParamAnnotation;
 
 /**
@@ -6,31 +9,24 @@
  * All accessors are used by ReflectionAccess.
  */
+@FramsClassAnnotation(id = "j")
 public class Joint extends BaseJoint {
 
-	/** i */
+	@ParamAnnotation(id = "i")
 	public String info;
-	public String getI() { return info; }
-	public void setI(String i) { info = i; }
 
-	/** p1 */
-	public Integer part1;
-	public void setP1(Integer p1) { part1 = p1; }
-	public Integer getP1() { return part1; }
+	@ParamAnnotation(id = "p1")
+	public int part1;
 
-	/** p2 */
-	public Integer part2;
-	public void setP2(Integer p2) { part2 = p2; }
-	public Integer getP2() { return part2; }
+	@ParamAnnotation(id = "p2")
+	public int part2;
 
+	@ParamAnnotation(id = "stam")
+	public double stamina;
 
-	/** stam */
-	public Double stamina;
-	public Double getStam() { return stamina; }
-	public void setStam(Double stam) { stamina = stam; }
+	@ParamAnnotation(id = "Vstyle")
+	public String visualizationStyle;
 
+	@ParamAnnotation
+	public double vr, vg, vb;
 
-	/** Vstyle */
-	public String visualizationStyle;
-	public String getVstyle() { return visualizationStyle; }
-	public void setVstyle(String Vstyle) { visualizationStyle = Vstyle; }
 }
Index: /java/main/src/main/java/com/framsticks/model/MechJoint.java
===================================================================
--- /java/main/src/main/java/com/framsticks/model/MechJoint.java	(revision 85)
+++ /java/main/src/main/java/com/framsticks/model/MechJoint.java	(revision 86)
@@ -1,17 +1,17 @@
 package com.framsticks.model;
+
+import com.framsticks.params.annotations.FramsClassAnnotation;
+import com.framsticks.params.annotations.ParamAnnotation;
 
 /**
  * @author Piotr Sniegowski
  */
+@FramsClassAnnotation
 public class MechJoint extends BaseJoint {
 
-	/** stress */
-	public Double stress;
-	public Double getStress() { return stress; }
-	public void setStress(Double stress) { this.stress = stress; }
+	@ParamAnnotation
+	public double stress;
 
-	/** rotstress */
-	public Double rotationStress;
-	public Double getRotstress() { return rotationStress; }
-	public void setRotstress(Double rotstress) { rotationStress = rotstress; }
+	@ParamAnnotation(id = "rotstress")
+	public double rotationStress;
 }
Index: /java/main/src/main/java/com/framsticks/model/MechPart.java
===================================================================
--- /java/main/src/main/java/com/framsticks/model/MechPart.java	(revision 85)
+++ /java/main/src/main/java/com/framsticks/model/MechPart.java	(revision 86)
@@ -1,16 +1,17 @@
 package com.framsticks.model;
 
+import com.framsticks.params.annotations.FramsClassAnnotation;
+import com.framsticks.params.annotations.ParamAnnotation;
 import com.framsticks.util.math.Point3d;
 
 /*
  */
+@FramsClassAnnotation
 public class MechPart extends BasePart {
 
-	/** vol */
-	public Double volume = 0.0;
-	public Double getVol() { return volume; }
-	public void setVol(Double vol) { volume = vol; }
+	@ParamAnnotation(id = "vol")
+	public double volume = 0.0;
 
-	/** vx, vy, vz*/
+	@ParamAnnotation
 	public double vx, vy, vz;
 
Index: /java/main/src/main/java/com/framsticks/model/Model.java
===================================================================
--- /java/main/src/main/java/com/framsticks/model/Model.java	(revision 85)
+++ /java/main/src/main/java/com/framsticks/model/Model.java	(revision 86)
@@ -1,4 +1,6 @@
 package com.framsticks.model;
 
+import com.framsticks.params.annotations.FramsClassAnnotation;
+import com.framsticks.params.annotations.ParamAnnotation;
 import com.framsticks.util.lang.Casting;
 import com.framsticks.util.lang.Containers;
@@ -14,32 +16,45 @@
  * Author: Piotr Śniegowski
  */
+@FramsClassAnnotation(id = "m")
 public class Model {
 
 	private final static Logger log = Logger.getLogger(Model.class);
 
-	public Double startingEnergy;
-	public Double getEnerg0() { return startingEnergy; }
-	public void setEnerg0(Double energ0) { startingEnergy = energ0; }
+	@ParamAnnotation(id = "se")
+	public double startingEnergy;
 
-	public Double getSe() { return startingEnergy; }
-	public void setSe(Double se) { startingEnergy = se; }
+	@ParamAnnotation
+	public double getEnerg0() { return startingEnergy; }
+	@ParamAnnotation
+	public void setEnerg0(double energ0) { startingEnergy = energ0; }
 
-	/** Vstyle */
+
+	@ParamAnnotation(id = "Vstyle")
 	public String visualizationStyle;
-	public String getVstyle() { return visualizationStyle; }
-	public void setVstyle(String Vstyle) { visualizationStyle = Vstyle; }
 
+	@ParamAnnotation
 	public final List<Part> parts = new ArrayList<Part>();
+
+	@ParamAnnotation
 	public final List<Joint> joints = new ArrayList<Joint>();
+
+	@ParamAnnotation
 	public final List<NeuroDef> neurodefs = new ArrayList<NeuroDef>();
 
-	public Double getNumparts() { return (double)parts.size(); }
-	public Double getNumjoints() { return (double)joints.size(); }
-	public Double getNumneurons() { return (double)neurodefs.size(); }
+	//TODO: why those methods returns and accepts doubles?
+	@ParamAnnotation
+	public double getNumparts() { return (double)parts.size(); }
+	@ParamAnnotation
+	public double getNumjoints() { return (double)joints.size(); }
+	@ParamAnnotation
+	public double getNumneurons() { return (double)neurodefs.size(); }
 
 	//this is impossible to use, because numparts field is marked as readonly
-	public void setNumparts(Double numparts) { Containers.resizeList(parts, (int) (double) numparts); }
-	public void setNumjoints(Double numjoints) { Containers.resizeList(joints, (int)(double)numjoints); }
-	public void setNumneurons(Double numneurons) { Containers.resizeList(neurodefs, (int)(double)numneurons); }
+	@ParamAnnotation
+	public void setNumparts(double numparts) { Containers.resizeList(parts, (int) (double) numparts); }
+	@ParamAnnotation
+	public void setNumjoints(double numjoints) { Containers.resizeList(joints, (int)(double)numjoints); }
+	@ParamAnnotation
+	public void setNumneurons(double numneurons) { Containers.resizeList(neurodefs, (int)(double)numneurons); }
 
 	public List<Part> getParts() { return parts; }
@@ -78,6 +93,6 @@
 		for (Joint j : f0Genotype.getJoints()) {
 			/** based on c++ Joint::attachToParts*/
-			Part p1 = f0Genotype.parts.get(j.getP1());
-			Part p2 = f0Genotype.parts.get(j.getP2());
+			Part p1 = f0Genotype.parts.get(j.part1);
+			Part p2 = f0Genotype.parts.get(j.part2);
 			assert p1 != null && p2 != null;
 			Orientation o = new Orientation().rotate(j.getRotation());
Index: /java/main/src/main/java/com/framsticks/model/Neuro.java
===================================================================
--- /java/main/src/main/java/com/framsticks/model/Neuro.java	(revision 85)
+++ /java/main/src/main/java/com/framsticks/model/Neuro.java	(revision 86)
@@ -1,4 +1,6 @@
 package com.framsticks.model;
 
+import com.framsticks.params.annotations.FramsClassAnnotation;
+import com.framsticks.params.annotations.ParamAnnotation;
 import com.framsticks.util.math.Point3d;
 
@@ -6,20 +8,26 @@
  * @author Piotr Sniegowski
  */
+@FramsClassAnnotation
 public class Neuro extends BaseNeuro {
 
-	public Integer channelCount;
+	@ParamAnnotation
+	public int channelCount;
 
-	public Double inputSum;
+	@ParamAnnotation
+	public double inputSum;
 
-	public Double weightedInputSum;
+	@ParamAnnotation
+	public double weightedInputSum;
 
-	public Double state;
+	@ParamAnnotation
+	public double state;
 
-	public Double currentState;
-	public Double getCurrState() { return currentState; }
-	public void setCurrState(Double currState) { currentState = currState; }
+	@ParamAnnotation(id = "currState")
+	public double currentState;
 
-	public Boolean hold;
+	@ParamAnnotation
+	public boolean hold;
 
+	@ParamAnnotation
 	public double position_x, position_y, position_z;
 
Index: /java/main/src/main/java/com/framsticks/model/NeuroDef.java
===================================================================
--- /java/main/src/main/java/com/framsticks/model/NeuroDef.java	(revision 85)
+++ /java/main/src/main/java/com/framsticks/model/NeuroDef.java	(revision 86)
@@ -1,40 +1,27 @@
 package com.framsticks.model;
+
+import com.framsticks.params.annotations.FramsClassAnnotation;
+import com.framsticks.params.annotations.ParamAnnotation;
 
 /**
  * @author Piotr Sniegowski
  */
+@FramsClassAnnotation(id = "n")
 public class NeuroDef extends BaseNeuro {
 
-	/** p */
-	public Integer part;
+	@ParamAnnotation(id = "p")
+	public int part;
 
-	/** j */
-	public Integer joint;
+	@ParamAnnotation(id = "j")
+	public int joint;
 
-	/** d */
+	@ParamAnnotation(id = "d")
 	public String details;
 
-	/** i */
+	@ParamAnnotation(id = "i")
 	public String info;
 
-	/** Vstyle */
+	@ParamAnnotation(id = "Vstyle")
 	public String visualizationStyle;
 
-	public Integer getP() { return part; }
-	public void setP(Integer p) { part = p; }
-
-	public Integer getJ() { return joint; }
-	public void setJ(Integer j) { joint = j; }
-
-	public String getD() { return details; }
-	public void setD(String d) { details = d; }
-
-	public String getI() { return info; }
-	public void setI(String i) { info = i; }
-
-	public String getVstyle() { return visualizationStyle; }
-	public void setVstyle(String Vstyle) { visualizationStyle = Vstyle; }
-
-
-
 }
